#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char **argv)
{
        int err = 0;
    if (argc!=3)
    {
        printf("getlabel <label> <filename.noi>\n");
      err = 2;
    }
    else
    {
      
        FILE *fh = fopen(argv[2],"r");
        if (fh==NULL)
        {
          printf("Can't open file %s\n", argv[2]);
          err = 1;
        }
        else
        {
            char buffer[1024];
            size_t line_length = 0;
            int got_label = 0;
          
            char *line = fgets(buffer, sizeof(buffer), fh);
            while ((line!=NULL) && (got_label==0))
            { 
                char *tok;
                int got_def = 0;
              
              tok = strtok (line," ");
                while (tok != NULL)
                {
                  if (got_label)
                  {
			  // sdcc is starting to output with 0: prefix
			  // on labels in noi
			  //
			  // if we find a : output after otherwise keep
			  char *pTok = strchr(tok, ':');
			  if (pTok!=NULL)
			  {
				  fprintf(stdout, "%s", pTok+1);
			  }
			  else
			  {
				  fprintf(stdout, "%s", tok);
			  }
                      break;
                  }
                  else
                  if (got_def)
                  {
                      if (strcmp(tok, argv[1])==0)
                      {
                          got_label = 1;
                      }
                      else
                      {
                        break;
                      }
                    }
                  else
                  {
                    if (strcmp(tok,"DEF")==0)
                    {
                        got_def = 1;
                    }
                  }
                    
                  tok = strtok (NULL, " ");
                }
            
                line = fgets(buffer, sizeof(buffer), fh);
         }

          if (!got_label)
            err = 3;
          
          fclose(fh);
        }
      }
    return err;
}